// <!-- Copyright (c) 2005 - 2006 WatchMouse BV. All rights reserved. -->
//
// by hm van Staveren
//

var updateDelay;
var updateUnit;
var cks;

var req; 										// XMLHttpRequest
var longhistory = new Array(72);				// storage
var checkIndex = 0;								
var errorIndex = 0;								

var signalErrorCount = 0;
var timerInterval = null;
var oldUrl = "";
var oldAction = false;
var allreadySignaled = false;

var WMPIn;
var WMTotalRules = 0;
var WMActivesRules = 0;
var WMLastRuleWithError;


var localizedStrings = new Object; 
var startUp = true;
var fsUpdate = false;

function willHide() {
 //;
}

function willShow() {
	if(!startUp) {
 		if (document.getElementById('r2').checked) { //wmnet
 			//asBeep();
 			doRealWMAction(true);
 		}
 	}
 	else startUp = false;
}

function update() {
	if (timerInterval != null) {
		clearInterval(timerInterval);
		timerInterval = null;
	}
	if (document.getElementById('r1').checked ) { //local
		if (document.getElementById('netplace').src != "images/netplaceholder.png") {
			document.getElementById('netplace').src = "images/netplaceholder.png";
		}
		document.getElementById('availbanner').innerHTML = getLocalizedString('AVAILABILITY LAST 72 HOURS');
		timerInterval = setTimeout("update()",(updateDelay*1000));
		pull();
	}
	else { // from the mice
		document.getElementById('availbanner').innerHTML = getLocalizedString('&nbsp&nbsp;WORLDWIDE MONITORING');
		timerInterval = setTimeout("update()",(300*1000)); // 5 minutes for network
		if (fsUpdate) {
			doRealWMAction(false);
			doRealWMAction(true);
		}
		else doRealWMAction(false);
		
	}
	fsUpdate = false;
}

function almostDone() {
	setTimeout("almostDoneDelayed()",(1*100));
}

function almostDoneDelayed() {
	var hasUpdated = false;
	fsUpdate = true;
	setUnit();
	
	// fix url or missing uri scheme - we support http, https and ftp
	var ch = document.getElementById('checkurl').value.substr(0,6);
	
	document.getElementById('checkurl').value = document.getElementById('checkurl').value.replace(/,/ig,".");
	
	
	if (document.getElementById('checkurl').value == "") {
		// NOP
	}
	else if (document.getElementById('checkurl').value == "http://") {
		document.getElementById('checkurl').value= "";
	}
	else if (document.getElementById('checkurl').value == "https://") {
		document.getElementById('checkurl').value= "";
	}
	else if (document.getElementById('checkurl').value == "ftp://") {
		document.getElementById('checkurl').value= "";
	}
	else if ((ch != "http:/") && (ch != "https:") && (ch != "ftp://")) {
		document.getElementById('checkurl').value = "http://"+document.getElementById('checkurl').value;
	}
		
	document.getElementById("lcdText").style.color="black";
	document.getElementById('lcdText').style.background='url(Images/lcd-green.png) no-repeat top left';

	
	if (document.getElementById('r1').checked) {
		document.getElementById('base').src = "Images/base72.png";
		if (oldUrl != document.getElementById('checkurl').value)  {
			// new url - reset all counters stuff and force pull
		
			ableSelect();
			longhistory = new Array(72);
			updateGraph(true); // ? do we need this
		
			willRemove();
			update();
			hasUpdated = true;
		}
		if (!hasUpdated) {
			setTimeout("update()",(100));
		}
	}
	else {
		clearGraph();
		document.getElementById('base').src = "Images/base72b.png";
		if (!hasUpdated) {
			setTimeout("update()",(100));
		}
		
		if (!getWMRules(false)) {
			displayMessage(getLocalizedString("Error retrieving rules"),true);
		}
	}

	setPrefs();
	markOldUrl();
	
}

function markOldUrl() {
	oldUrl = document.getElementById('checkurl').value;
 	oldAction=document.getElementById('r1').checked;
}


function setUnit() {
	if (document.getElementById('freqq').options.selectedIndex == 0) {
		cks = new Array(100,98,96,95,94,92,90,88,86,84,85,82,80,78,76,75,74,70,68,66,64,62,60,58,56,54,55,52,50,48,46,45,44,42,40,38,35,36,34,32,30,28,26,25,24,22,20,18,16,15,14,12,10,8,6,5,4,2,0);
		updateUnit = 59;
	 	updateDelay = 60;
		//updateUnit = 3;
	 	//updateDelay = 1;
	}
	else if (document.getElementById('freqq').options.selectedIndex == 1) {
		cks = new Array(100,92,83,75,66,58,50,41,33,25,16,8,0);
		updateUnit = 11;
	 	updateDelay = 300;
	}
	else if (document.getElementById('freqq').options.selectedIndex == 2) {
		cks = new Array(100,75,50,25,0);
		updateUnit = 3;
	 	updateDelay = 900;
	}
	else if (document.getElementById('freqq').options.selectedIndex == 3) {
		cks = new Array(100,50,0);
		updateUnit = 2;
	 	updateDelay = 1800;
	}
	else {
		cks = new Array(100,0);
		updateUnit = 1;
	 	updateDelay = 3600;
	}
}

function growlNotify(cmd, title, txt) {
	try { 
		var status = widget.system("/usr/bin/osascript Applescripts/growlNotifications.scpt notify "+cmd+" "+title+" "+txt, null).status; 
	} 
	catch (e) { }

}


function loaded() {
	try { 
		var status = widget.system("/usr/bin/osascript Applescripts/growlNotifications.scpt register", null).status; 
	} 
	catch (e) { }

	
	
	checkVersion();
	
	document.getElementById('lcdText').style.background='url(Images/lcd-green.png) no-repeat top left';
	

	
	if (window.widget) {
		
		widget.onhide = onhide;
		widget.onshow = onshow;
		widget.onremove = onremove;
		
		doPrefs();
	
	    setUnit();
		initGraph();
		
		if (document.getElementById('r2').checked) {
			if (!getWMRules(true)) {
				displayMessage(getLocalizedString("Error retrieving rules"),true);
			}
		}
		
	}
	
	createGenericButton (document.getElementById('done'), getLocalizedString('Done'), doneClicked, 60);	
	
	if (document.getElementById('r2').checked) document.getElementById('base').src = "Images/base72b.png";

	
	//set strings
	document.getElementById('version').innerHTML = widgetVersion;
	document.getElementById('MonitoringWidget').innerHTML = getLocalizedString('Monitoring Widget');
	document.getElementById('Watchfromthis').innerHTML = getLocalizedString('Watch from this computer');
	document.getElementById('Watchfromnet').innerHTML = getLocalizedString('Watch from the worldwide network');
	document.getElementById('urlLoc').innerHTML = getLocalizedString('URL');
	document.getElementById('freq').innerHTML = getLocalizedString('Check every');
	document.getElementById('locEmail').innerHTML = getLocalizedString('E-mail');
	document.getElementById('locPassword').innerHTML = getLocalizedString('Password');
	document.getElementById('registerLink').innerHTML = getLocalizedString('Register');
	document.getElementById('displayLoc').innerHTML = getLocalizedString('Display');
	document.getElementById('periodLoc').innerHTML = getLocalizedString('Period');
	document.getElementById('WM-network').innerHTML = getLocalizedString('Join the WM-network');
	document.getElementById('warnLoc').innerHTML = getLocalizedString('Warn on errror');
	document.getElementById('availbanner').innerHTML = getLocalizedString('AVAILABILITY LAST 72 HOURS');

	document.getElementById('layp').innerHTML = getLocalizedString('There is a new version of this widget available.') + "<p>";	
	document.getElementById('dlnlink').innerHTML = getLocalizedString('Download now');	
	document.getElementById('dlllink').innerHTML = getLocalizedString('Download later');	
		
	//set spec loc strings
	document.getElementById('helpLocal').style.left = getLocalizedString('Local Help Icon Offset');
	document.getElementById('helpNetwerk').style.left = getLocalizedString('Net Help Icon Offset');
	document.getElementById('helpp2p').style.left =  getLocalizedString('P2P Help Icon Offset');
	
	// delayed startup check //
	fsUpdate = true;
	setTimeout("update()",(1*1000));


}

function pull() {
	if (document.getElementById('checkurl').value) {
	
		// reset green
		document.getElementById('lcdText').style.color='black';
		document.getElementById('lcdText').style.background='url(Images/lcd-green.png) no-repeat top left';

		d1 = document.getElementById('checkurl').value.split('://')[1].split('/')[0];
		document.getElementById('lcdText').innerHTML = getLocalizedString('Checking')+'<br/ >' + d1.substr(0,25);
		var ckurl = document.getElementById('checkurl').value; // + '?watchmouse='+(new Date()).getTime();
		req = new XMLHttpRequest();
		req.onreadystatechange = pullReadyStateChange;
		req.open("HEAD", ckurl, true); // no need to fetch the whole page
		req.send(null);
	}
	else {
		// need to set prefs!
		document.getElementById('lcdText').innerHTML = getLocalizedString("Please, set the preferences<br />on the back of the widget.");
	}
}

function pullReadyStateChange() {
	if (req.readyState == 4) { // complete
		switch ((req.status) ? req.status : 0) {
			case 0: 
				// NOT FOUND SITE IS PROBABLY DOWN :-(
				parseReply("Not Found");
				break;
			case 200:
				// HEADERS RECEIVED - NO PROBLEMS
				parseReply("OK");
				break;
			default: 
				// HTTP ERROR
				parseReply("HTTP ERROR " + req.status);
		}
		if (checkIndex < updateUnit) {
			checkIndex++;
			document.getElementById("m0").style.height = cks[errorIndex];
		}
		else {
			checkIndex = 0;
			// Update the longhistory
			addTolonghistory(cks[errorIndex]);
			errorIndex = 0;
		}
	}
}

function lineError() {
		req = new XMLHttpRequest();
		req.open("HEAD", 'http://www.watchmouse.com/', false);
		req.send(null);
		if ((req.readyState == 4) && (req.status==200)) return false;
		else return true;
}


function addTolonghistory(value) {
	longhistory.pop();
	longhistory.reverse();
	longhistory.push(value);
	longhistory.reverse();
	updateGraph(true); // and save and update the graphics
}

function initGraph() {
	for (var t=0;t<72;t++) {
		longhistory[t] = (widget.preferenceForKey(prefskey("m"+t))) ? widget.preferenceForKey(prefskey("m"+t)) : 0;
	}
	updateGraph(false);
}

function updateGraph(doSave) {
	for (var t=0;t<72;t++) {
		if (t<71) document.getElementById("m"+(t+1)).style.height = longhistory[t];
		if ((doSave) && (longhistory[t] >0)) widget.setPreferenceForKey(longhistory[t], prefskey("m"+t));
	}
}

function clearGraph() {
	for (var t=0;t<72;t++) {
		document.getElementById("m"+(t)).style.height = 0;
	}
}


function parseReply(reply) {
	var lerror = false;
	if (reply == 'OK') {
		//document.getElementById('lcdText').style.color='black';
		//document.getElementById('lcdText').style.background='url(Images/lcd-green.png) no-repeat top left';
		signalErrorCount = 0;
		allreadySignaled = false;
	}
	else {
		if (lineError()==false) {
			document.getElementById("lcdText").style.color="white";
			document.getElementById('lcdText').style.background='url(Images/lcd-red.png) no-repeat top left';
			errorIndex++;
			// are we gonna signal it?
			if (document.getElementById('warn').options[document.getElementById('warn').options.selectedIndex].value  != '-1') {
				
				if (document.getElementById('warn').options[document.getElementById('warn').options.selectedIndex].value  == signalErrorCount) {
					signalErrorCount = 0; //reset first
					signalError();	
				}
				else {
					signalErrorCount++;
				}
			}
		}
		else {
			lerror = true;
			//document.getElementById('lcdText').style.color='red';
			//document.getElementById('lcdText').style.background='url(Images/lcd-green.png) no-repeat top left';
			document.getElementById("lcdText").style.color="white";
			document.getElementById('lcdText').style.background='url(Images/lcd-red.png) no-repeat top left';
		}
	}
	
	// create display stuff
	var time = new Date().toLocaleTimeString().split(' ')[0];
	var d1 = document.getElementById('checkurl').value.split('://')[1].split('/')[0];
	var displayUrl = d1.substr(0,25);
	
	// fix localisation 'reply' here
	reply = reply.replace(/Not found/ig,getLocalizedString("Not Found"));
	reply = reply.replace(/ERROR/ig,getLocalizedString("ERROR"));
	
	if (lerror==false) {
		
		var txt = displayUrl + '<br />' + time + ' &raquo; ' + reply ; //+ ' '+checkIndex+ ' '+updateUnit+ ' '+updateDelay;
		
		var txtg = getLocalizedString('Checked') + ': ' + displayUrl + ' '+ getLocalizedString('at')+' ' + time + "\n\n"+getLocalizedString('Status')+": " + reply ; // + ' '+checkIndex+ ' '+updateUnit+ ' '+updateDelay;
	
	}
	else {
		
		var txt = getLocalizedString("PAUSED <br />No connection");
		
		var txtg = getLocalizedString("PAUSED - No connection");

		}
	
	document.getElementById('lcdText').innerHTML = txt;
	
	if (reply == 'OK') growlNotify("Check from this computer", "Watchmouse", "\""+txtg+"\"");
	else growlNotify("Error", "Watchmouse", "\""+txtg+"\"");
}

function signalError() {
	if (!allreadySignaled) {
		allreadySignaled = true;
		if (window.widget) {
			if (document.getElementById('r1').checked ) { //local
				widget.openURL('http://www.watchmouse.com/checkit.php?vurl='+encodeURI(document.getElementById('checkurl').value)+'&m=10309&c=widget&v='+widgetVersion);
			}
			else { // from net
				widget.openURL('http://www.watchmouse.com/status.php?vrule='+encodeURI(WMLastRuleWithError)+'&m=10309&c=widget&v='+widgetVersion);		
			}
		}
		// Applescript for sys beep
		asBeep();
	}
}

function asBeep() {
		// Applescript for sys beep
		try {
			var res =  widget.system("/usr/bin/osascript Applescripts/signalError.scpt", null).outputString;
		} 
		catch (e) {}
}


function ableSelect() {
		signalErrorCount = 0;
		checkIndex = 0;								
		errorIndex = 0;
		allreadySignaled = false;
}

function downloadLater() {
	document.getElementById('overlay').style.display='none';
	if (document.getElementById('r2').checked ) { 
		document.getElementById('base').src = "Images/base72b.png";
	}
}

function downloadNow() {
		if (window.widget) widget.openURL('http://www.watchmouse.com//widget/dashboard_widget.php?c=widget&v='+widgetVersion);
		document.getElementById('overlay').style.display='none';
		if (document.getElementById('r2').checked ) { 
			document.getElementById('base').src = "Images/base72b.png";
		}
}


function setFromThis() {
	if (document.getElementById('r1').checked) {
		document.getElementById('checkurl').disabled = false;
		document.getElementById('freqq').disabled = false;

		document.getElementById('liname').disabled = true;
		document.getElementById('lipass').disabled = true;
		document.getElementById('fperiod').disabled = true;
		document.getElementById('fdisplay').disabled = true;
	
	}
	else {
		document.getElementById('checkurl').disabled = true;
		document.getElementById('freqq').disabled = true;

		document.getElementById('liname').disabled = false;
		document.getElementById('lipass').disabled = false;
		document.getElementById('fperiod').disabled = false;
		document.getElementById('fdisplay').disabled = false;
		
	}
}
