function displayMessage(txt, error) {
	if (!error) {
		document.getElementById("lcdText").style.color="black";
		document.getElementById('lcdText').style.background='url(Images/lcd-green.png) no-repeat top left';
	}
	else {
		document.getElementById("lcdText").style.color="white";
		document.getElementById('lcdText').style.background='url(Images/lcd-red.png) no-repeat top left';
	}
	document.getElementById('lcdText').innerHTML = txt;
}

function getWMPin(login,password) {
	reqq = new XMLHttpRequest();
    reqq.open("GET", "http://www.watchmouse.com/api/1.3/acct_pin.php?user="+login+"&password="+password,false);
    reqq.send(null);
	if ((reqq.readyState == 4) && (reqq.status == 200)) {
 		var pinNodes = reqq.responseXML.getElementsByTagName('pin');
 		if (pinNodes.length>0) return pinNodes.item(0).firstChild.nodeValue;
 		else return 0;
	}
	else return 0;
}

function getWMStatus(login,pin) {
	var WMErrors = 0;
	reqq = new XMLHttpRequest();
	if (document.getElementById('fdisplay').options.selectedIndex==0) {
    	reqq.open("GET", "http://www.watchmouse.com/api/1.3/rule_get.php?user="+login+"&pin="+pin,false);
    }
    else {
    	var rule = document.getElementById('fdisplay').options[document.getElementById('fdisplay').options.selectedIndex].value;
    	reqq.open("GET", "http://www.watchmouse.com/api/1.3/rule_get.php?user="+login+"&pin="+pin+"&name="+rule,false);    
    }
    reqq.send(null);
	if ((reqq.readyState == 4) && (reqq.status == 200)) {
		try {
			var errorNodes = reqq.responseXML.getElementsByTagName('errors');
			var nameNodes = reqq.responseXML.getElementsByTagName('name');
			var activeNodes = reqq.responseXML.getElementsByTagName('active');
			var lastcheckNodes = reqq.responseXML.getElementsByTagName('lastcheck');
			var WMTotalRules = nameNodes.length;
		}
		catch(e) {
			//displayMessage(getLocalizedString("No active rules found"),true);
			//asBeep();
			return false;
		}
		if (WMTotalRules>0) {
			var cc = 1;
			for(var counter=0;counter<WMTotalRules;counter++) {
   				if (activeNodes.item(counter).firstChild.nodeValue == "y") {
    				if(errorNodes.item(counter).firstChild.nodeValue > 0) {
    					WMErrors++;
    					WMLastRuleWithError = nameNodes.item(counter).firstChild.nodeValue;
     				}
     				cc++;
     				lastcheck = lastcheckNodes.item(counter).firstChild.nodeValue;
     			}
    		}
			if (cc==1) {
				displayMessage(getLocalizedString("No active rules found"),true);
				asBeep();
				return false;
    		}
    		else {
    			WMActivesRules = cc-1;
    			//var time = lastcheck.split(' ')[1];
    			var time = new Date().toLocaleTimeString().split(' ')[0];
       			if (WMErrors == 0) {
     				signalErrorCount = 0;
					allreadySignaled = false;
					// display OK
					if (document.getElementById('fdisplay').options.selectedIndex==0) {
						displayMessage(WMActivesRules+" "+getLocalizedString("Rules")+"<br />"+time+" &raquo; OK",false);
					}
					else {
						var rule = document.getElementById('fdisplay').options[document.getElementById('fdisplay').options.selectedIndex].value;
						if (rule.length > 23) rule = rule.substr(0, 23)+"...";
						displayMessage(rule+"<br />"+time+" &raquo; OK",false);
					}
				}
				else {
				   	if (document.getElementById('warn').options[document.getElementById('warn').options.selectedIndex].value  != '-1') {
						if (document.getElementById('warn').options[document.getElementById('warn').options.selectedIndex].value  == signalErrorCount) {
							signalErrorCount = 0; //reset first
							signalError();	
						}
						else {
							signalErrorCount++;
						}
					}
					// errors
					if (document.getElementById('fdisplay').options.selectedIndex==0) {
						txt = WMActivesRules+" "+getLocalizedString("Rules")+"<br />"+time+" &raquo; "+WMErrors+" ";
						txtg = WMActivesRules+" "+getLocalizedString("Rules")+"\n\n"+time+" - "+WMErrors+" ";
						if (WMErrors == 1) {
							txt += getLocalizedString("Error");
							txtg += getLocalizedString("Error");
						}
						else {
							txt += getLocalizedString("Errors");
							txtg += getLocalizedString("Errors");
						}
						displayMessage(txt,true);
						growlNotify("Error", "Watchmouse", "\""+txtg+"\"");
					}
					else {
						var rule = document.getElementById('fdisplay').options[document.getElementById('fdisplay').options.selectedIndex].value;
						if (rule.length > 23) rule = rule.substr(0, 23)+"...";
						txtg = rule+"\n\n"+time+" - "+getLocalizedString("Error");
						displayMessage(rule+"<br />"+time+" &raquo; "+getLocalizedString("Error"),true);
						growlNotify("Error", "Watchmouse", "\""+txtg+"\"");
					}
				}
      			return true;
     		}
 		}
 		else {
			displayMessage(getLocalizedString("No active rules found"),true);
			asBeep();
			return false;
		}
	}
	else {
		displayMessage(getLocalizedString("Error retrieving rules"),true);
		asBeep();
		return false;
	}
}



function getWMRules(flag) {
	if ((document.getElementById('liname').value =="") || (document.getElementById('lipass').value =="") ) {
			 //authError();
	}
	else {
		pin = getWMPin(document.getElementById('liname').value,document.getElementById('lipass').value);
	}
	try {
		if ( pin == 0) {
			return false;
		}
	}
	catch(e) {
		return false;
	}

	var login = document.getElementById('liname').value;
	reqq = new XMLHttpRequest();
    reqq.open("GET", "http://www.watchmouse.com/api/1.3/rule_get.php?user="+login+"&pin="+pin,false);
    reqq.send(null);
	if ((reqq.readyState == 4) && (reqq.status == 200)) {
		try {
 			var nameNodes = reqq.responseXML.getElementsByTagName('name');
 			var activeNodes = reqq.responseXML.getElementsByTagName('active');
 			var WMTotalRules = nameNodes.length;
 		}
 		catch(e) {
 			return false;
 		}
 		var se = document.getElementById('fdisplay').options.selectedIndex;
		if (WMTotalRules>0) {
			document.getElementById('fdisplay').options.length = 1;
  			var cc = 1;
 			for(var counter=0;counter<WMTotalRules;counter++) {
   				if (activeNodes.item(counter).firstChild.nodeValue == "y") {
   					document.getElementById('fdisplay').options.length = cc + 1;
    				document.getElementById('fdisplay').options[cc] = new Option(nameNodes.item(counter).firstChild.nodeValue, nameNodes.item(counter).firstChild.nodeValue, false, false);
    				cc++;
     			}
    		}
    		if (cc==1) {
				return false;
    		}
    		else {
    			WMActivesRules = cc-1;
     			
     			if (!flag) document.getElementById('fdisplay').options.selectedIndex = se;
     			else {
     				document.getElementById('fdisplay').options.selectedIndex =  widget.preferenceForKey(prefskey("display"));
     			}
     			return true;
     		}
    	}
    	 else {
			return false;
		}

    }
    else {
		return false;
	}
}


function getWMGraph(login,pin) {
	if (document.getElementById('fdisplay').options.selectedIndex==0) {
		var qstr = "http://www.watchmouse.com/api/1.3/rule_graph.php?user="+login+"&pin="+pin+"&type=avail";
	}
	else {
		var qstr = "http://www.watchmouse.com/api/1.3/rule_graph.php?user="+login+"&pin="+pin+"&type=avail&name=";
		var rule = document.getElementById('fdisplay').options[document.getElementById('fdisplay').options.selectedIndex].value;
		qstr += rule;
	}
	
	qstr += WMPeriod();
	qstr += "&dummy="+(new Date()).getTime(); // beat the cache
	
	if (document.getElementById('checkurl').value == 'http://debug') { 
		widget.openURL(qstr);
	}

	document.getElementById('netplace').src = qstr;
}


function doRealWMAction(flag) {	
	
	if ((document.getElementById('liname').value =="") || (document.getElementById('lipass').value =="") ) {
			 authError();
	}
	else {
		WMPIn = getWMPin(document.getElementById('liname').value,document.getElementById('lipass').value);
		if ( WMPIn> 0) {
			// logged in
			if (flag){
				getWMGraph(document.getElementById('liname').value,WMPIn);
			}
			else {
				getWMStatus(document.getElementById('liname').value,WMPIn);
			}
		}
		else {
			 authError();
		}
	}
}


function authError() {

	if (lineError()) {
		var txt = getLocalizedString("PAUSED <br />No connection");
		
		document.getElementById('lcdText').innerHTML = txt;
		return;
	}
	
	document.getElementById('base').src = "Images/base72b.png";
	document.getElementById('netplace').src = "images/netplaceholder.png";
	displayMessage(getLocalizedString("Authentication error, please, check the preferences."),false);
	document.getElementById('lipass').value = "";
}

function WMPeriod() {
	var s = document.getElementById('fperiod').options.selectedIndex;
	var d = new Date;
	var dd = new Array(31,30,31,30,31,30,31,31,30,31,30,31);

	var ddd = new Date();
	var y = ddd.getFullYear()
	var m = ddd.getMonth() + 1; if (m<10) m = "0" +m;
	var t = ddd.getDate(); if (t<10) t = "0" +t;
	var ed = "&end_date="+y+"-"+m+"-"+t;
	
	switch (s) {
			case 0: 
				// 24 hr
				//var b = d.getTime() - (24 * 3600 * 1000);
				var d = new Date();
				var y = d.getFullYear()
				var m = d.getMonth() + 1; if (m<10) m = "0" +m;
				var t = d.getDate(); if (t<10) t = "0" +t;
				var e = "&start_date="+y+"-"+m+"-"+t + "&end_date="+y+"-"+m+"-"+t ;
				break;
			case 1: 
				// last 7 days;
				var b = d.getTime() - (7* 24 * 3600 * 1000);
				var d = new Date(b);
				var y = d.getFullYear()
				var m = d.getMonth() + 1; if (m<10) m = "0" +m;
				var t = d.getDate(); if (t<10) t = "0" +t;
				var e = "&start_date="+y+"-"+m+"-"+t + ed;
				break;
			case 2: 
				//last 30 days
				var b = d.getTime() - (30 * 24 * 3600 * 1000);
				var d = new Date(b);
				var y = d.getFullYear()
				var m = d.getMonth() + 1; if (m<10) m = "0" +m;
				var t = d.getDate(); if (t<10) t = "0" +t;
				var e = "&start_date="+y+"-"+m+"-"+t + ed;
				break;
			case 3: 
				// this month
				var l = d.getDate() - 1;
				var b = d.getTime() - (24 * 3600 * 1000 * l);
				var d = new Date(b);
				var y = d.getFullYear()
				var m = d.getMonth() + 1; if (m<10) m = "0" +m;
				var t = d.getDate(); if (t<10) t = "0" +t;
				var e = "&start_date="+y+"-"+m+"-"+t + ed;
				break;				
			case 4: 
				// last month
				var l = d.getMonth();
				if (l==0) { // happy new year
					var y = d.getFullYear() - 1;
					var e = "&start_date="+y+"-12-01&end_date="+y+"-12-31";
				}
				else {
					var y = d.getFullYear();
					if (l<10) var ld = "0" +l;
					else var ld = l;
					var e = "&start_date="+y+"-"+ld+"-01&end_date="+y+"-"+ld+"-"+dd[l];
				}
				break;				
		}
	//displayMessage(e);	
	return e;	
}